
#include "SPI.h"
#include "ILI9341_t3.h"
//#include <CmdMessenger.h>  // CmdMessenger

// For the Adafruit shield, these are the default.
#define TFT_DC  9
#define TFT_CS 10

const int LCD_FRAME_RATE = 30;

long previousMillis = 0;

bool serialStarted = false;
bool serialEnded = false;
char inData[80];
int serIndex;

int counterA = 0;
int counterB = 0;

ILI9341_t3 tft = ILI9341_t3(TFT_CS, TFT_DC);

void setup() {
  
  tft.begin();
  tft.setRotation(3);
  tft.fillScreen(ILI9341_BLACK);
  tft.setTextColor(ILI9341_YELLOW, ILI9341_BLACK);
  tft.setTextSize(2);
  tft.setCursor(10, 220); 
  tft.print("loading...");

  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  //while (!Serial) ; // wait for Arduino Serial Monitor
  Serial.println("Ready!"); // this seems to be required

  tft.fillScreen(ILI9341_BLACK);

}

void loop() {

  readSerial();

  //update the LCD display at the set frame rate
  if ((millis() - previousMillis) > (1000.0 / (float)LCD_FRAME_RATE))
  {
    updateDisplay();
    previousMillis = millis();
  }
  
}

void updateDisplay() {

  tft.setCursor(10, 100); 
  tft.print(counterA);

  tft.setCursor(10, 200); 
  tft.print(counterB);

}

void readSerial() {

  //Read Serial
  while(Serial.available() > 0)
  {
    char c = Serial.read();
    if(c=='#'){
      serIndex = 0;
      inData[serIndex] = '\0';
      serialStarted = true;
    }else if(c=='/'){
      serialEnded = true;
      break;
    }else{
      if(serIndex < 79){
        inData[serIndex] = c;
        serIndex++;
        inData[serIndex] = '\0';
      }
    }
  }

  //Process Serial Package
  if(serialStarted && serialEnded){
  
    String PrintString = String(inData);
  
    int commaIndex = PrintString.indexOf('_');
    int secondCommaIndex = PrintString.indexOf('_', commaIndex+1);
  
    String part1 = PrintString.substring(0, commaIndex);
    String part2 = PrintString.substring(commaIndex+1, secondCommaIndex);
  
    if (part1.equals("msa")) {
      counterA = part2.toFloat();
    } else if (part1.equals("msb")) {
      counterB = part2.toFloat();
    }

  }

}
